'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = composeWithRedux;

var _compose = require('../compose');

var _compose2 = _interopRequireDefault(_compose);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeReduxBase(fn, props, onData) {
  if (!props.context) {
    throw new Error('No context passed as prop.');
  }

  var context = typeof props.context === 'function' ? props.context() : props.context;
  var Store = context.Store || context.store;

  if (!Store) {
    throw new Error('No store found in the context');
  }

  var processState = function processState() {
    try {
      var state = Store.getState();
      var data = fn(state, props);
      onData(null, data);
    } catch (ex) {
      onData(ex);
    }
  };

  processState();
  Store.subscribe(processState);
}

function composeWithRedux(fn, L1, E1) {
  var options = arguments.length <= 3 || arguments[3] === undefined ? { displayName: 'WithRedux' } : arguments[3];

  return (0, _compose2.default)(composeReduxBase.bind(null, fn), L1, E1, options);
}