'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _getDisplayName = require('../utils/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapHandlers = function mapHandlers(handlers, func) {
  var result = {};

  /* eslint-disable no-restricted-syntax */
  for (var key in handlers) {
    if (handlers.hasOwnProperty(key)) {
      result[key] = func(handlers[key], key);
    }
  }

  return result;
};

function composeWithHandlers(handlers) {
  return function (ChildComponent) {
    var WithHandlers = function (_Component) {
      (0, _inherits3.default)(WithHandlers, _Component);

      function WithHandlers() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, WithHandlers);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(WithHandlers)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.cachedHandlers = {}, _this.handlers = mapHandlers(handlers, function (createHandler, handlerName) {
          var cachedHandler = _this.cachedHandlers[handlerName];
          if (cachedHandler) {
            return cachedHandler;
          }

          var handler = createHandler.bind(null, _this.props);
          _this.cachedHandlers[handlerName] = handler;

          if (typeof handler !== 'function') {
            var message = 'withHandlers(): Expected a function.';
            throw new Error(message);
          }

          return handler;
        }), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(WithHandlers, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps() {
          this.cachedHandlers = {};
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(ChildComponent, (0, _extends3.default)({}, this.handlers, this.props));
        }
      }]);
      return WithHandlers;
    }(_react.Component);

    WithHandlers.displayName = 'WithHandlers(' + (0, _getDisplayName2.default)(ChildComponent) + ')';

    return (0, _hoistNonReactStatics2.default)(WithHandlers, ChildComponent);
  };
}

exports.default = composeWithHandlers;